--message('Here is the new addon')
vrpConfig = {}
RPBS = {} --Addon pointer


local RPBSAddon = CreateFrame("Frame", "RPBSAddon", UIParent) --Used to reference the addon and respond to events
local RegisteredEvents = {} --Array to hold our events we want to respond to
CHAT_MSG_PREFIX = "RPBS_CHAT"
local CHAT_ADDON_NAME = "<RPBS> "

--Use to track the raid record we are using (should be the first record used to create the start points)
local Current_Raid = {}

--Used to track the Zone Name
local realmName
local Current_Raid_Zone = "No Zone"
local current_raid_difficulty = nil

--used to track who has a bidding window open (from master looter perspective)
local Bidder_Window_Count = 0

--used to track the current player points
Current_Points = 0
local player
Master_Looter = nil
bML = false
local bAllBiddingStopped = false
local lastLootSource = nil


local BADGE_OF_JUSTICE = "Badge of Justice"
local EMBLEM_OF_HEROISM = "Emblem of Heroism"
local EMBLEM_OF_VALOR = "Emblem of Valor"
local EMBLEM_OF_CONQUEST = "Emblem of Conquest"
local lootpatterns, unsortedloot, currentsort

RPBSAddon:SetScript("OnEvent", function (self, event, ...) if (RegisteredEvents[event]) then return RegisteredEvents[event](self, event, ...) end end)

--List all the events we want to respond to as an array of RegisteredEvents
function RegisteredEvents:ADDON_LOADED(event, addon, ...)
	if(addon == "RPBS" ) then
		print("|cFF00FF00 -=RPBS=- |r|cFFFFFFFF v1.0 Loaded. |r|cFFFFFF00 Type /rpbs for usage |r|cFFFFFFFF")
		SLASH_VRP1 = '/rpbs'
		SlashCmdList["VRP"] = function (msg, editbox)
			RPBS.SlashCmdHandler(msg, editbox)	
		end
		setmetatable(vrpConfig, {__index = DefaultConfig})
		
		RPBS.CreateUI()
		RPBSBidUI.CreateBidUI()
		RPBS:PrepareDB()
		RPBS:OnInitialize()
		RPBS.UpdatePointsText()
		RPBS.RegisterForAddonMessages()

	end
end

function RPBS.RegisterForAddonMessages()
	RegisterAddonMessagePrefix(CHAT_MSG_PREFIX);
end

function RegisteredEvents:PLAYER_LOGIN(event)
	print('Welcome to |cFF00FF00 -=RPBS=- |r|cFFFFFFFF Player. You have ' .. Current_Points .. " points to spend on gear")
	--RPBSBar.Show()
	--print("bar.Show()")
end


--build the loot display frame for the ML

bOverrideLootThreshold = false
--Process our loot window here (should be done by the master looter)
function RegisteredEvents:LOOT_OPENED(event)

	local t = 1
	local loottemp = {}
	local sockets = {3, 497, 523, 563, 564, 565, 572}
	local warforged = {44, 448, 499, 546, 547, 560, 561, 562, 571}
	local bShowLootDisplay = false
	local bAlreadyLooted = false

--	local masterlooterRaidID = select(3, GetLootMethod())
--	if (masterlooterRaidID ~= nil and UnitName("raid"..masterlooterRaidID) == UnitName("player")) or IsLeftControlKeyDown() then
	if(bML) then
		if(lastLootSource == GetLootSourceInfo(1)) then
			bAlreadyLooted = true
		end

		local n = 0
--		local check = false
		local loot = GetLootInfo()

--		for i = 1, GetNumLootItems() do
--			if GetLootSlotType(i) == 1 then
--				for j = 1, t do
--					if GetLootSourceInfo(i) == loottemp[j] then 
--						check = true
--						break
--					end
--				end
--			end
--		end

		if bAlreadyLooted == false then
			RPBS.ResetLootButtons()
			t = GetNumLootItems()
			for i = 1, t do
				loot[i]["check"] = 0
				--if GetLootSlotType(i) == 1 and loot[i]["quality"] >= 4 and not (bit.band(GetItemFamily(loot[i]["item"] or '') or 0, 0x0040) > 0) then
				if (GetLootSlotType(i) == 1 and loot[i]["quality"] >= GetLootThreshold()) or (bOverrideLootThreshold) then -- and not (bit.band(GetItemFamily(loot[i]["item"] or '') or 0, 0x0040) > 0) then
					local link = GetLootSlotLink(i)
					local ilvl = select(4, GetItemInfo(link))
					loot[i]["upgrade"] = ""
					loot[i]["link"] = link
					local itemstring = string.match(link, "item[%-?%d:]+")
					local numbonuses = select(14, strsplit(":", itemstring))
					if(numbonuses == "") then
						numbonuses = "0"
					end
					numbonuses = tonumber(numbonuses)
					local bonus = {}
					for j = 1, numbonuses do
						bonus[j] = select(14 + j, strsplit(":", itemstring))
						bonus[j] = tonumber(bonus[j])
						for k = 1, #warforged do											--Warforged
							if bonus[j] == warforged[k] then
								loot[i]["upgrade"] = loot[i]["upgrade"]..":"..ilvl
							end
						end
						for k = 1, #sockets do															--Socket
							if bonus[j] == sockets[k] then
								loot[i]["upgrade"] = loot[i]["upgrade"].." o"
							end
						end
						if bonus[j] == 40 then loot[i]["upgrade"] = loot[i]["upgrade"].." +"..STAT_AVOIDANCE end						--Avoidance
						if bonus[j] == 41 then loot[i]["upgrade"] = loot[i]["upgrade"].." +"..STAT_LIFESTEAL end						--Leech
						if bonus[j] == 42 then loot[i]["upgrade"] = loot[i]["upgrade"].." +"..STAT_SPEED end							--Speed
						if bonus[j] == 43 then loot[i]["upgrade"] = loot[i]["upgrade"].." +"..STAT_STURDINESS end						--Indestructible
					end
					loot[i]["check"] = 1
					for k = 1, i-1 do
						if loot[k]["item"] == loot[i]["item"] and loot[k]["upgrade"] == loot[i]["upgrade"] then
							loot[i]["check"] = 0
							loot[k]["quantity"] = loot[i]["quantity"] + loot[k]["quantity"]
						end
					end
				end
			end

			lastLootSource = GetLootSourceInfo(1)
			
			--Display the loot in the chat window
			for i = 1, t do
				loot[i]["item"] = GetLootSlotLink(i)
				if loot[i]["check"] == 1 then
					bShowLootDisplay = true
					n = n + 1
					if loot[i]["quantity"] == 1 then
						print(n..". "..loot[i]["item"]..loot[i]["upgrade"])
						SendChatMessage(n..". "..loot[i]["item"]..loot[i]["upgrade"], "RAID")
					else
						print(n..". "..loot[i]["item"].."x"..loot[i]["quantity"].."  "..loot[i]["upgrade"])
						SendChatMessage(n..". "..loot[i]["item"].."x"..loot[i]["quantity"].."  "..loot[i]["upgrade"], "RAID")
					end
					RPBS.SetLootButton(loot[i], i)
				end
			end
			if(bShowLootDisplay) then
				RPBS.ShowLootDisplay()
			end
		end

		for i = 1, t do
			loottemp[i] = GetLootSourceInfo(i)
		end
	end

end

function RegisteredEvents:GROUP_ROSTER_UPDATE(event)
	--print("Raid Roster was modified Group")
	--need to check to see if the master looter has changed

	local numRaiders = GetNumGroupMembers();

	for index = 1, numRaiders, 1 do
		name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(index)
		if(isML) then
			Master_Looter = name
		end
	end

	--Update the interface if we are the master looter
	if(player == Master_Looter) then
		bML = true
		RPBS.ShowMasterLooter()
	else
		bML = false
		RPBS.HideMasterLooter()
	end

end

function RegisteredEvents:CHAT_MSG_ADDON(event, prefix, message, channel, target)
	--print("CHAT_MSG_ADDON Prefix: " .. prefix)
	--print("CHAT_MSG_ADDON Mesage: " .. message)
	if(prefix == CHAT_MSG_PREFIX) then
		local msgType, msgData, playerName = strsplit("-", message, 3)

		if(msgType == "KillPt") then
			if(playerName == player or playerName == "none") then
				RPBS.AddPoints(tonumber(msgData))
			end
		end

		if(msgType == "AttendPt") then
			if(playerName == player or playerName == "none") then
				RPBS.AddPoints(tonumber(msgData))
			end
		end

		if(msgType == "EndPt") then
			if(playerName == player or playerName == "none") then
				RPBS.AddPoints(tonumber(msgData))
			end
		end

		if(msgType == "StupidPt") then
			if(playerName == player or playerName == "none") then
				RPBS.RemovePoints(tonumber(msgData))
			end
		end

		if(msgType == "AwesomePt") then
			if(playerName == player or playerName == "none") then
				RPBS.AddPoints(tonumber(msgData))
			end
		end

		if(msgType == "PlaceBid") then
			if(bML) then
				RPBSBidUI.UpdateHighBid(msgData, playerName)
			else
				RPBSBidUI.UpdateHighBid(msgData)
			end
		end

		if(msgType == "StartBidding") then
			--Get the item from the message (its the 4th parameter)
			local item = select(4,strsplit("-", message, 4))
			bAllBiddingStopped = false
			RPBS.HideLootDisplay()
			RPBSBidUI.StartBidding(item)
			if(bML) then
				BidMonitorUI.ShowUI()
			end
		end

		if(msgType == "BidWindowOpen") then
			Bidder_Window_Count = Bidder_Window_Count + 1
			BidMonitorUI.PlayerOpenedBidding(playerName)
		end

		if(msgType == "BidWindowClose") then
			Bidder_Window_Count = Bidder_Window_Count - 1
			BidMonitorUI.PlayerClosedBidding(playerName)
			--print("Bid Windows Count " .. Bidder_Window_Count)
			if(Bidder_Window_Count < 2 and bML) then
				Bidder_Window_Count = 0
				--This should be only the lootmaster window at this point, call the end button click function from the Bid UI
				if(bAllBiddingStopped == false) then
					bAllBiddingStopped = true
					--Update the ML display to indicate no one else is going to Bid
					RPBSBidUI.ShowFinalBid()
				end
			end
		end

		if(msgType == "EndBidding") then
			RPBSBidUI.EndBidding()
			if(bML) then
				BidMonitorUI.HideUI()
				RPBS.ShowLootDisplay()
			end
			Bidder_Window_Count = 0
			if(playerName == player) then
				RPBS.RemovePoints(tonumber(msgData))
			end
		end

		if(msgType == "AddonCheck") then
			RPBS.AddonCheckReply()
		end

		if(msgType == "AddonCheckReply") then
			--Upoate the Frame
			print("|cFF00FF00 -=RPBS=- |r|cFFFFFFFF Addon Verified: " .. playerName .. " |r|cFFFFFF00(" .. msgData .. ")|r|cFFFFFFFF")
		end


	end
end

function RegisteredEvents:OnEnable()
	print("RegisteredEvents:OnEnable()")
    RPBSAddon:RegisterEvent("RAID_INSTANCE_WELCOME")
    RPBSAddon:RegisterEvent("CHAT_MSG_LOOT")

	print("RegisteredEvents:OnEnable() Completed")


end

function RegisteredEvents:OnDisable()
	self:UnregisterAllEvents()
end


--Loop through all events and call them in our array of registered events
for k, v in pairs(RegisteredEvents) do
	RPBSAddon:RegisterEvent(k)
end


function RPBS.SlashCmdHandler(msg, editbox)
	--print("command is " .. msg .. "\n")
	if (string.lower(msg) == "ml") then
		--RegisteredEvents:OnEnable()
		bML = true
		RPBS.ShowMasterLooter()
	elseif (string.lower(msg) == "show") then
		RPBS.ShowUI()
	elseif (string.lower(msg) == "hide") then
		RPBS.HideUI()
	elseif (string.lower(msg) == "looton") then
		bOverrideLootThreshold = true
	elseif (string.lower(msg) == "lootoff") then
		bOverrideLootThreshold = false
	elseif (string.lower(msg) == "check") then
		RPBS.AddonCheck()
	elseif (string.lower(msg) == "resetpoints") then
		if(bML) then
			RPBS.ResetPoints()
		end
	else
		RPBS.ShowHelp()
	end
end

function RPBS.ShowHelp()
	print("Slash commands (/rpbs):")
	print(" /rpbs show: Open addon")
	print(" /rpbs hide: Close addon")
	print(" /rpbs check: List players with the addon and version")
end

function RPBS:PrepareDB()
	--print("Preaparing DB...")
	if not (RPBSDB) then
		RPBSDB = {}
	end
	--Verify we have a real record for the current realm
	realmName = nil
	for i,v in pairs(RPBSDB) do
		if (i == GetRealmName()) then
			realmName = i
		end
	end
	if(realmName == nil) then
		--no realm exists in the DB need to create one
		realmName = GetRealmName()
		--print("adding record for realm " .. realmName)
		RPBSDB[realmName] = {["raid"]={}, PlayerPoints={}, ["MyPoints"]=0} -- used to track the raids played and payouts that occur
	end

	--establish our Globals
	Current_Points = RPBSDB[realmName].MyPoints

end

function RPBS:OnInitialize()

	--print("OnInitialized Running...")

	player = UnitName('player')
end



function RPBS.RemovePoints(points)
	if(Current_Points > 0) then
		Current_Points = Current_Points - points
		RPBSDB[realmName].MyPoints = Current_Points
		RPBS.UpdatePointsText()
	end
end

function RPBS.AddPoints(points)
	Current_Points = Current_Points + points
	RPBSDB[realmName].MyPoints = Current_Points
	RPBS.UpdatePointsText()
end

function RPBS.ResetPoints(playerName)
	if(playerName ~= nil) then
		if(playerName == player) then
			Current_Points = 0
		end
	else
		Current_Points = 0
	end
	RPBSDB[realmName].MyPoints = Current_Points
	RPBS.UpdatePointsText()
end

---------------------------------
--UI Elements
---------------------------------
local fVRP = CreateFrame("Frame","frmVRP",UIParent)
local fLootMasterControls = CreateFrame("Frame","frmLootMasterControls",UIParent)
local fLootDisplay = CreateFrame("Frame","frmLootDisplay",UIParent)

--Later I will add a frame to track the addon, for now I am just putting the reponses into the chat window
--local fAddonCheck = CreateFrame("Frame","frmAddonCheck",UIParent)

function RPBS.CreateUI()
	fVRP:SetBackdrop({
		  bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
		  edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
		  tile=1, tileSize=32, edgeSize=32, 
		  insets={left=11, right=12, top=12, bottom=11}
	})



	fVRP:SetWidth(220)
	fVRP:SetHeight(45)
	fVRP:SetPoint("CENTER",UIParent)
	fVRP:EnableMouse(true)
	fVRP:SetMovable(true)
	fVRP:RegisterForDrag("LeftButton")
	fVRP:SetScript("OnDragStart", function(self) self:StartMoving() end)
	fVRP:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	fVRP:SetFrameStrata("MEDIUM")

	fVRP:SetPoint("CENTER",200,0)
	
	local btnCloseVRP = CreateFrame("Button","btnCloseVRP",fVRP, "UIPanelCloseButton")
	btnCloseVRP:SetSize(32 ,32) -- width, height
	btnCloseVRP:SetPoint("TOPRIGHT", -5, -5)
	btnCloseVRP:SetScript("OnClick", function() RPBS.HideUI() end)

	vrpFS = fVRP:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	vrpFS:SetPoint("TOP", 0, -17)

	fVRP:Hide()

--Build the loot master control buttons frame
	fLootMasterControls:SetBackdrop({
		  bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
		  edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
		  tile=1, tileSize=32, edgeSize=32, 
		  insets={left=11, right=12, top=12, bottom=11}
	})



	fLootMasterControls:SetWidth(220)
	fLootMasterControls:SetHeight(135)
	fLootMasterControls:SetPoint("CENTER",UIParent)
	fLootMasterControls:EnableMouse(true)
	fLootMasterControls:SetMovable(true)
	fLootMasterControls:RegisterForDrag("LeftButton")
	fLootMasterControls:SetScript("OnDragStart", function(self) self:StartMoving() end)
	fLootMasterControls:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	fLootMasterControls:SetFrameStrata("MEDIUM")

	fLootMasterControls:SetPoint("CENTER",200,0)

	local titleLootFS = fLootMasterControls:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	titleLootFS:SetPoint("TOP", 0, -15)
	titleLootFS:SetText(" RPBS Point Control")

	RPBS.BuildMasterLooter()

	RPBS.HideMasterLooter()
end



function RPBS.BuildMasterLooter()

	--create a button to call our functions
	local btnClose = CreateFrame("Button","btnClose",fLootMasterControls, "UIPanelCloseButton")
	btnClose:SetSize(32 ,32) -- width, height
--	btnClose:SetText("X")
	btnClose:SetPoint("TOPRIGHT", -5, -5)
	btnClose:SetScript("OnClick", function() RPBS.HideMasterLooter() end)

	local btnAttend = CreateFrame("Button","btnAttend",fLootMasterControls, "UIPanelButtonTemplate")
	btnAttend:SetSize(80 ,25) -- width, height
	btnAttend:SetText("Attend Pt")
	btnAttend:SetPoint("BOTTOMLEFT", 15, 60)
	btnAttend:SetScript("OnClick", function() RPBS.btnAttend() end)

	local btnKill = CreateFrame("Button","btnKill",fLootMasterControls, "UIPanelButtonTemplate")
	btnKill:SetSize(80 ,25) -- width, height
	btnKill:SetText("Kill Pt")
	btnKill:SetPoint("BOTTOMLEFT", 15, 35)
	btnKill:SetScript("OnClick", function() RPBS.btnKill() end)

	local btnKill = CreateFrame("Button","btnComplete",fLootMasterControls, "UIPanelButtonTemplate")
	btnComplete:SetSize(80 ,25) -- width, height
	btnComplete:SetText("End Pt")
	btnComplete:SetPoint("BOTTOMLEFT", 15, 10)
	btnComplete:SetScript("OnClick", function() RPBS.btnEnd() end)

	local btnAwsome = CreateFrame("Button","btnAwsome",fLootMasterControls, "UIPanelButtonTemplate")
	btnAwsome:SetSize(80 ,25) -- width, height
	btnAwsome:SetText("Awesome")
	btnAwsome:SetPoint("BOTTOMRIGHT", -15, 10)
	btnAwsome:SetScript("OnClick", function() RPBS.btnAwesome() end)

--	local btnTest = CreateFrame("Button","btnTest",fLootMasterControls, "UIPanelButtonTemplate")
--	btnTest:SetSize(80 ,25) -- width, height
--	btnTest:SetText("Test")
--	btnTest:SetPoint("BOTTOMRIGHT", -15, 60)
--	btnTest:SetScript("OnClick", function() RPBS.btnTest() end)

	local btnStupid = CreateFrame("Button","btnStupid",fLootMasterControls, "UIPanelButtonTemplate")
	btnStupid:SetSize(80 ,25) -- width, height
	btnStupid:SetText("Stupid Pt")
	btnStupid:SetPoint("BOTTOMRIGHT", -15, 35)
	btnStupid:SetScript("OnClick", function() RPBS.btnStupid() end)
end



--Build the loot display Frame
	local iLootButtonSize = 280
	-- use this to store the linkitem text for each loot we get


	fLootDisplay:SetBackdrop({
		  bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
		  edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
		  tile=1, tileSize=32, edgeSize=32, 
		  insets={left=11, right=12, top=12, bottom=11}
	})



	fLootDisplay:SetWidth(300)
	fLootDisplay:SetHeight(400)
	fLootDisplay:SetPoint("CENTER",UIParent)
	fLootDisplay:EnableMouse(true)
	fLootDisplay:SetMovable(true)
	fLootDisplay:RegisterForDrag("LeftButton")
	fLootDisplay:SetScript("OnDragStart", function(self) self:StartMoving() end)
	fLootDisplay:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	fLootDisplay:SetFrameStrata("MEDIUM")

	fLootDisplay:SetPoint("CENTER",200,0)

	local titleLootDisplayFS = fLootDisplay:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	titleLootDisplayFS:SetPoint("TOP", 0, -15)
	titleLootDisplayFS:SetText("Loot For Bid")

	local btnClose = CreateFrame("Button","btnClose", fLootDisplay, "UIPanelCloseButton")
	btnClose:SetSize(32 ,32) -- width, height
--	btnClose:SetText("X")
	btnClose:SetPoint("TOPRIGHT", -5, -5)
	btnClose:SetScript("OnClick", function() RPBS.CloseLootDisplay() end)

	local btnLoot1 = CreateFrame("Button","btnLoot1", fLootDisplay, "UIPanelButtonTemplate")
	btnLoot1:SetSize(iLootButtonSize ,25) -- width, height
	btnLoot1:SetText("")
	btnLoot1:SetPoint("TOP", 0, -45)

	local btnLoot2 = CreateFrame("Button","btnLoot2", fLootDisplay, "UIPanelButtonTemplate")
	btnLoot2:SetSize(iLootButtonSize ,25) -- width, height
	btnLoot2:SetText("")
	btnLoot2:SetPoint("TOP", 0, -75)

	local btnLoot3 = CreateFrame("Button","btnLoot3", fLootDisplay, "UIPanelButtonTemplate")
	btnLoot3:SetSize(iLootButtonSize ,25) -- width, height
	btnLoot3:SetText("")
	btnLoot3:SetPoint("TOP", 0, -105)

	local btnLoot4 = CreateFrame("Button","btnLoot4", fLootDisplay, "UIPanelButtonTemplate")
	btnLoot4:SetSize(iLootButtonSize ,25) -- width, height
	btnLoot4:SetText("")
	btnLoot4:SetPoint("TOP", 0, -135)

	local btnLoot5 = CreateFrame("Button","btnLoot5", fLootDisplay, "UIPanelButtonTemplate")
	btnLoot5:SetSize(iLootButtonSize ,25) -- width, height
	btnLoot5:SetText("")
	btnLoot5:SetPoint("TOP", 0, -165)

	local btnLoot6 = CreateFrame("Button","btnLoot6", fLootDisplay, "UIPanelButtonTemplate")
	btnLoot6:SetSize(iLootButtonSize ,25) -- width, height
	btnLoot6:SetText("")
	btnLoot6:SetPoint("TOP", 0, -195)

	local btnLoot7 = CreateFrame("Button","btnLoot7", fLootDisplay, "UIPanelButtonTemplate")
	btnLoot7:SetSize(iLootButtonSize ,25) -- width, height
	btnLoot7:SetText("")
	btnLoot7:SetPoint("TOP", 0, -225)

	local btnLoot8 = CreateFrame("Button","btnLoot8", fLootDisplay, "UIPanelButtonTemplate")
	btnLoot8:SetSize(iLootButtonSize ,25) -- width, height
	btnLoot8:SetText("")
	btnLoot8:SetPoint("TOP", 0, -255)

	fLootDisplay:Hide();


function RPBS.ResetLootButtons()

	btnLoot1:SetText("")
	btnLoot1:Hide()

	btnLoot2:SetText("")
	btnLoot2:Hide()

	btnLoot3:SetText("")
	btnLoot3:Hide()

	btnLoot4:SetText("")
	btnLoot4:Hide()

	btnLoot5:SetText("")
	btnLoot5:Hide()

	btnLoot6:SetText("")
	btnLoot6:Hide()

	btnLoot7:SetText("")
	btnLoot7:Hide()

	btnLoot8:SetText("")
	btnLoot8:Hide()
end

function RPBS.SetLootButton(loot, i)
	--i = i+1

	if(i==1) then 
		btnLoot1:SetText(loot["item"])
		btnLoot1:SetScript("OnClick", function() RPBS.BidItem(loot["link"]) end)
		btnLoot1:Show()
	elseif(i==2) then 
		btnLoot2:SetText(loot["item"])
		btnLoot2:SetScript("OnClick", function() RPBS.BidItem(loot["item"]) end)
		btnLoot2:Show()
	elseif(i==3) then 
		btnLoot3:SetText(loot["item"])
		btnLoot3:SetScript("OnClick", function() RPBS.BidItem(loot["item"]) end)
		btnLoot3:Show()
	elseif(i==4) then 
		btnLoot4:SetText(loot["item"])
		btnLoot4:SetScript("OnClick", function() RPBS.BidItem(loot["item"]) end)
		btnLoot4:Show()
	elseif(i==5) then 
		btnLoot5:SetText(loot["item"])
		btnLoot5:SetScript("OnClick", function() RPBS.BidItem(loot["item"]) end)
		btnLoot5:Show()
	elseif(i==6) then 
		btnLoot6:SetText(loot["item"])
		btnLoot6:SetScript("OnClick", function() RPBS.BidItem(loot["item"]) end)
		btnLoot6:Show()
	elseif(i==7) then 
		btnLoot7:SetText(loot["item"])
		btnLoot7:SetScript("OnClick", function() RPBS.BidItem(loot["item"]) end)
		btnLoot7:Show()
	elseif(i==8) then 
		btnLoot8:SetText(loot["item"])
		btnLoot8:SetScript("OnClick", function() RPBS.BidItem(loot["item"]) end)
		btnLoot8:Show()
	end

end

function RPBS.BidItem(item)

	--print("Bidding for " .. item)
	SendChatMessage("Bidding Started for " .. item ,"RAID");
	SendAddonMessage(CHAT_MSG_PREFIX, "StartBidding-0-none-" .. item,  RPBS.GetInstanceChannel());
	--BidMonitorUI.ShowUI()

end

function RPBS.CloseLootDisplay()
	fLootDisplay:Hide();
	if(bML) then
		RPBS.ShowMasterLooter()
	end
end

function RPBS.HideLootDisplay()
	fLootDisplay:Hide();
end

function RPBS.ShowLootDisplay()
	fLootDisplay:Show();
	RPBS.HideMasterLooter()
end

function RPBS.HideMasterLooter()
	fLootMasterControls:Hide();
end

function RPBS.ShowMasterLooter()
	fLootMasterControls:Show();
end

function RPBS.btnTest()
	print("Button Test")
	RPBSBidUI.ShowBidUI()
	print("Button test complete")
end

function RPBS.ShowUI()
	fVRP:Show()
end

function RPBS.HideUI()
	fVRP:Hide()
end

function RPBS.UpdatePointsText()
	vrpFS:SetText("Points to spend: " .. Current_Points)
end


function RPBS.btnStBid()
	SendChatMessage("Bidding Started" ,"RAID");
	SendAddonMessage(CHAT_MSG_PREFIX, "StartBidding-0-none",  RPBS.GetInstanceChannel());
end

function RPBS.btnAttend()
--	if(GetUnitName("target") ~= nil) then
--		SendChatMessage(GetUnitName("target") .. " is awarded a Attend point" , RPBS.GetInstanceChannel());
--		SendAddonMessage(CHAT_MSG_PREFIX, "AttendPt-1-" .. GetUnitName("target"), "RAID");
--	else
		SendChatMessage("RAID is awarded a Attend point" , RPBS.GetInstanceChannel());
		SendAddonMessage(CHAT_MSG_PREFIX, "AttendPt-1-none", "RAID");
--	end
end

function RPBS.btnKill()
	SendChatMessage("RAID is awarded a Boss Kill point" , RPBS.GetInstanceChannel());
	SendAddonMessage(CHAT_MSG_PREFIX, "KillPt-1-none", "RAID");
end

function RPBS.btnEnd()
	SendChatMessage("RAID is awarded a Completion point" , RPBS.GetInstanceChannel());
	SendAddonMessage(CHAT_MSG_PREFIX, "EndPt-1-none", "RAID");
end

function RPBS.btnStupid()
	if(GetUnitName("target") ~= nil) then
		SendChatMessage(GetUnitName("target") .. " was deducted a point for being Stupid!" , RPBS.GetInstanceChannel());
		SendAddonMessage(CHAT_MSG_PREFIX, "StupidPt-1-" .. GetUnitName("target"), "RAID");
	else
		SendChatMessage("RAID was deducted a Stupid point" ,RPBS.GetInstanceChannel());
		SendAddonMessage(CHAT_MSG_PREFIX, "StupidPt-1-none", "RAID");
	end
end

function RPBS.btnAwesome()
	if(GetUnitName("target") ~= nil) then
		SendChatMessage(GetUnitName("target") .. " receives a point for being AWESOME!" , RPBS.GetInstanceChannel());
		SendAddonMessage(CHAT_MSG_PREFIX, "AwesomePt-1-" .. GetUnitName("target"), "RAID");
	else
		SendChatMessage("Everyone receives a point for being AWESOME!" , RPBS.GetInstanceChannel());
		SendAddonMessage(CHAT_MSG_PREFIX, "AwesomePt-1-none" , "RAID");
	end
end

function RPBS.AddonCheck()
--	SendChatMessage("RAID is awarded a Completion point" , RPBS.GetInstanceChannel());
	SendAddonMessage(CHAT_MSG_PREFIX, "AddonCheck-0-" .. UnitName('player'), "RAID");
end

function RPBS.AddonCheckReply()
--	SendChatMessage("RAID is awarded a Completion point" , RPBS.GetInstanceChannel());
	SendAddonMessage(CHAT_MSG_PREFIX, "AddonCheckReply-" .. GetAddOnMetadata("RPBS","Version") .. "-" .. UnitName('player'), "RAID");
end

function RPBS.GetInstanceChannel()
	iCount = GetNumGroupMembers();
	if(iCount > 0 and iCount < 6) then
		--we are in at least a party
		return "PARTY"
	end
	if(iCount > 5) then
		return "RAID"
	end
	return ""
end


